IGP extension for PCEP security capability support in PCE discovery
Diego R. Lopez
Telefonica I+D
Spain
diego.r.lopez@telefonica.com
Qin Wu
Huawei Technologies
101 Software Avenue, Yuhua District
Nanjing
Jiangsu
210012
China
bill.wu@huawei.com
Dhruv Dhody
Huawei Technologies
Divyashree Techno Park, Whitefield
Bangalore
Karnataka
560037
India
dhruv.ietf@gmail.com
Qiufang Ma
Huawei
101 Software Avenue, Yuhua District
Nanjing
Jiangsu
210012
China
maqiufang1@huawei.com
Daniel King
Old Dog Consulting
UK
daniel@olddog.co.uk
2022
Routing Area
PCE working group
RFC
Request for Comments
I-D
Internet-Draft
Path Computation Element
When a Path Computation Element (PCE) is a Label Switching Router (LSR) participating in the Interior Gateway Protocol (IGP), or even a server participating in the IGP, its presence and path computation capabilities can be advertised using IGP flooding. The IGP extensions for PCE discovery (RFC 5088 and RFC 5089) define a method to advertise path computation capabilities using IGP flooding for OSPF and IS-IS respectively. However these specifications lack a method to advertise PCE Communication Protocol (PCEP) security (e.g., Transport Layer Security (TLS), TCP Authentication Option (TCP-AO)) support capability.
This document defines capability flag bits for the PCE-CAP-FLAGS sub-TLV that can be announced as an attribute in the IGP advertisement to distribute PCEP security support information. In addition, this document updates RFC 5088 and RFC 5089 to allow advertisement of a Key ID or Key Chain Name Sub-TLV to support TCP-AO security capability. Further, this document updates RFC 8231, and RFC 8306.

Introduction
As described in [RFC5440], PCEP communication privacy is one important issue, as an attacker that intercepts a Path Computation Element (PCE) message could obtain sensitive information related to computed paths and resources.
Among the possible solutions mentioned in that document, Transport Layer Security (TLS) [RFC8446] provides support for peer authentication, and message encryption and integrity while TCP Authentication Option (TCP-AO) [RFC5925] and Cryptographic Algorithms for TCP-AO [RFC5926] offer significantly improved security for applications using TCP. As specified in section 4 of [RFC8253], in order for a Path Computation Client (PCC) to establish a connection with a PCE server using TLS or TCP-AO, the PCC needs to know whether PCE server supports TLS or TCP-AO as a secure transport.
[RFC5088] and [RFC5089] define a method to advertise path computation capabilities using IGP flooding for OSPF and IS-IS respectively. However these specifications lack a method to advertise PCEP security (e.g., TLS) support capability.
This document defines capability flag bits for the PCE-CAP-FLAGS sub-TLV that can be announced as attributes in the IGP advertisement to distribute PCEP security support information. In addition, this document updates [RFC5088] and [RFC5089] to allow advertisement of a Key ID or Key Chain Name Sub-TLV to support TCP-AO security capability.
As per [RFC5088], the IANA created a top-level OSPF registry, the "Path Computation Element (PCE) Capability Flags" registry. This document updates [RFC5088] and moves the registry to "Interior Gateway Protocol (IGP) Parameters". Further, this document updates [RFC8231] where it references the registry location as "Open Shortest Path First (OSPF) Parameters" registry to "Interior Gateway Protocol (IGP) Parameters" registry. This document updates [RFC8306] where it uses the term "OSPF PCE Capability Flag" and request assignment from OSPF Parameters registry with "PCE Capability Flag" and the IGP Parameters registry.
Note that [RFC5557] uses the term "OSPF registry" instead of the "IGP registry" where as [RFC8623] and [RFC9168] uses the term "OSPF Parameters" instead of "IGP Parameters".
Note that the PCEP Open message exchange is another way to discover PCE capabilities information, but in this instance, the TCP security related key parameters need to be known before the PCEP session is established and the PCEP Open messages are exchanged. Thus, the use of the PCE discovery and capabilities advertisement of the IGP needs to be leveraged.

Conventions used in this document
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.

IGP extension for PCEP security capability support
[RFC5088] defines a PCE Discovery (PCED) TLV carried in an OSPF Router Information Link State Advertisement (LSA) as defined in [RFC7770] to facilitate PCE discovery using OSPF. This document defines two capability flag bits in the OSPF PCE Capability Flags to indicate TCP Authentication Option (TCP-AO) support [RFC5925][RFC5926] and PCEP over TLS support [RFC8253] respectively.
Similarly, [RFC5089] defines the PCED sub-TLV for use in PCE discovery using IS-IS. This document will use the same flag for the OSPF PCE Capability Flags sub-TLV to allow IS-IS to indicate TCP Authentication Option (TCP-AO) support, PCEP over TLS support respectively.
The IANA assignments for shared OSPF and IS-IS Security Capability Flags are documented in Section 8.1 ("PCE Capability Flags") of this document.

Use of PCEP security capability support for PCE discovery
TCP-AO, PCEP over TLS support flag bits are advertised using IGP flooding.
- PCE supports TCP-AO: IGP advertisement SHOULD include TCP-AO support flag bit.
- PCE supports TLS: IGP advertisement SHOULD include PCEP over TLS support flag bit.
If the PCE supports multiple security mechanisms, it SHOULD include all corresponding flag bits in its IGP advertisement.
A client's configuration MAY indicate that support for a given security capability is required. If a client is configured to require that its PCE server supports TCP-AO, the client MUST verify that the TCP-AO flag bit in the PCE-CAP-FLAGS sub-TLV for a given server is set before it opens a connection to that server. Similarly, if the client is configured to require that its PCE server supports TLS, the client MUST verify that the PCEP over TLS support flag bit in the PCE-CAP-FLAGS sub-TLV for a given server is set before it opens a connection to that server.

KEY-ID Sub-TLV
The KEY-ID sub-TLV specifies an identifier that can be used by the PCC to identify the TCP-AO key [RFC5925].

IS-IS
The KEY-ID sub-TLV MAY be present in the PCED sub-TLV carried within the IS-IS Router CAPABILITY TLV when the capability flag bit of PCE-CAP-FLAGS sub-TLV in IS-IS is set to indicate TCP Authentication Option (TCP-AO) support.
The KEY-ID sub-TLV has the following format:
Type: 6
Length: 1
KeyID: The one octet Key ID as per [RFC5925] to uniquely identify the Master Key Tuple (MKT).

OSPF
Similarly, this sub-TLV MAY be present in the PCED TLV carried within OSPF Router Information LSA when the capability flag bit of PCE-CAP-FLAGS sub-TLV in OSPF is set to indicate TCP-AO support.
The format of KEY-ID sub-TLV is as follows:

                     1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|              Type = 6         |             Length            |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|    KeyID      |                 Reserved                      |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Type: 6
Length: 4
KeyID: The one octet Key ID as per [RFC5925] to uniquely identify the Master Key Tuple (MKT).
Reserved: MUST be set to zero while sending and ignored on receipt.

KEY-CHAIN-NAME Sub-TLV
The KEY-CHAIN-NAME sub-TLV specifies a keychain name that can be used by the PCC to identify the keychain [RFC8177].

IS-IS
The KEY-CHAIN-NAME sub-TLV MAY be present in the PCED sub-TLV carried within the IS-IS Router CAPABILITY TLV when the capability flag bit of the PCE-CAP-FLAGS sub-TLV in IS-IS is set to indicate TCP Authentication Option (TCP-AO) support.
The KEY-CHAIN-NAME sub-TLV has the following format:
Type: 7
Length: Variable, encodes the length of the value field.
Key Name: The Key Chain Name contains a string to be used to identify the key chain. It MUST be encoded using UTF-8. A receiving entity MUST NOT interpret invalid UTF-8 sequences. This field is not NULL terminated. UTF-8 "Shortest Form" encoding is REQUIRED to guard against the technical issues outlined in [UTR36].

OSPF
Similarly, this sub-TLV MAY be present in the PCED TLV carried within the OSPF Router Information LSA when the capability flag bit of PCE-CAP-FLAGS sub-TLV in OSPF is set to indicate TCP-AO support. The sub-TLV MUST be zero-padded so that the sub-TLV is 4-octet aligned.
The format of KEY-CHAIN-NAME sub-TLV is as follows:

                     1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|              Type = 7         |             Length            |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                                                               |
//                     Key Chain Name                          //
|                                                               |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Type: 7
Length: Variable,padding is not included in the Length field
Key Name: The Key Chain Name contains a string to be used to identify the key chain. It MUST be encoded using UTF-8. A receiving entity MUST NOT interpret invalid UTF-8 sequences. This field is not NULL terminated. UTF-8 "Shortest Form" encoding is REQUIRED to guard against the technical issues outlined in [UTR36]. The sub-TLV MUST be zero-padded so that the sub-TLV is 4-octet aligned.

Update to RFCs
Section 4 of [RFC5088] states that no new sub-TLVs will be added to the PCED TLV, and no new PCE information will be carried in the Router Information LSA. This document updates [RFC5088] by allowing the two sub-TLVs defined in this document to be carried in the PCED TLV advertised in the Router Information LSA.
Section 4 of [RFC5089] states that no new sub-TLVs will be added to the PCED TLV, and no new PCE information will be carried in the Router CAPABLITY TLV. This document updates [RFC5089] by allowing the two sub-TLVs defined in this document to be carried in the PCED TLV advertised in the Router CAPABILITY TLV.
This introduction of additional sub-TLVs should be viewed as an exception to the [RFC5088][RFC5089] policy, justified by the requirement to discover the PCEP security support prior to establishing a PCEP session. The restrictions defined in [RFC5089][RFC5089] should still be considered to be in place.
The registry for the PCE Capability Flags assigned in section 8.3 of [RFC5557], section 8.1 of [RFC8231], section 6.9 of [RFC8306], section 11.1 of [RFC8623], and section 10.5 of [RFC9168] has changed to the IGP Parameters "Path Computation Element (PCE) Capability Flags" registry created in this document.

Backward Compatibility Considerations
An LSR that does not support the IGP PCE capability bits specified in this document silently ignores those bits.
An LSR that does not support the KEY-ID and KEY-CHAIN-NAME sub-TLVs specified in this document silently ignores these sub-TLVs.
IGP extensions defined in this document do not introduce any new interoperability issues.

Management Considerations
A configuration option may be provided for advertising and withdrawing PCEP security capability via OSPF and IS-IS.

Security Considerations
Security considerations as specified by [RFC5088] and [RFC5089] are applicable to this document.
As described in Section 10.2 of [RFC5440], an PCEP speaker MUST support TCP MD5 [RFC2385], so no capability advertisement is needed to indicate support. However, as noted in [RFC6952], TCP MD5 has been obsoleted by TCP-AO [RFC5925] because of security concerns. However, TCP-AO is not widely implemented and so it is, therefore, RECOMMENDED (per [RFC8253] which updates [RFC5440]) that PCEP is secured using TLS. In any case, an implementation SHOULD offer at least one of the two security capabilities defined in this document.
The information related to PCEP security is sensitive and due care needs to be taken by the operator. This document defines new capability bits that are susceptible to a downgrade attack by setting them to zero. The content of Key ID or Key Chain Name Sub-TLV can be altered to enable a man-in-the-middle attack. Thus before advertising the PCEP security parameters, using the mechanism described in this document, the IGP MUST be known to provide authentication and integrity for the PCED TLV using the mechanisms defined in [RFC5304], [RFC5310] or [RFC5709].
Moreover, as stated in the Security Considerations of [RFC5088] and [RFC5089], there are no mechanisms defined in OSPF or IS-IS to protect the confidentiality of the PCED TLV. For this reason, the operator must ensure that no private data is carried in the TLV, e.g. that key-ids or key-chain names do not reveal sensitive information about the network.

IANA Considerations

PCE Capability Flags
IANA is requested to move the "Path Computation Element (PCE) Capability Flags" registry from the "Open Shortest Path First v2 (OSPFv2) Parameters" grouping to the "Interior Gateway Protocol (IGP) Parameters" grouping.
IANA is requested to make the following additional assignments from the "Path Computation Element (PCE) Capability Flags" registry.

     Bit           Capability Description  Reference
     xx            TCP-AO Support          [This.I.D]
     xx            PCEP over TLS support   [This.I.D]

The grouping is located at: https://www.iana.org/assignments/igp-parameters/igp-parameters.xhtml.

PCED sub-TLV Type Indicators
The PCED sub-TLVs were defined in [RFC5088] and [RFC5089], but they did not create a registry for it. This document requests IANA to create a new registry called "PCED sub-TLV type indicators" under the "Interior Gateway Protocol (IGP) Parameters" grouping. The registration policy for this registry is "IETF Review" [RFC8126]. Values in this registry come from the range 0-65535.
This registry should be populated with:

     Value         Description             Reference
     0             Reserved                [This.I.D][RFC5088]
     1             PCE-ADDRESS             [This.I.D][RFC5088]
     2             PATH-SCOPE              [This.I.D][RFC5088]
     3             PCE-DOMAIN              [This.I.D][RFC5088]
     4             NEIG-PCE-DOMAIN         [This.I.D][RFC5088]
     5             PCE-CAP-FLAGS           [This.I.D][RFC5088]
     6             KEY-ID                  [This.I.D]
     7             KEY-CHAIN-NAME          [This.I.D]

This registry is used by both the OSPF PCED TLV and the IS-IS PCED sub-TLV.
This grouping is located at: https://www.iana.org/assignments/igp-parameters/igp-parameters.xhtml.

Acknowledgments
The authors of this document would also like to thank Acee Lindem, Julien Meuric, Les Ginsberg, Ketan Talaulikar, Yaron Sheffer, Tom Petch, Aijun Wang, Adrian Farrel for the review and comments.
The authors would also like to special thank Michale Wang for his major contributions to the initial version.
Thanks to John Scudder for providing an excellent AD review.

Normative References

Informative References
[UTR36]

Unicode Technical Report #36, Character Encoding Model
M.Davis
February 2005
UTR17 http://www.unicode.org/unicode/reports/tr36/
[RFC5440]
[RFC8446]
[RFC5925]
[RFC5926]
[RFC8253]
[RFC5088]
[RFC5089]
[RFC2119]
[RFC8174]
[RFC7770]
[RFC8177]